package org.json;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

/**
 * JSONUtils
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class JSONUtils {

	public static void addObjectToJSONArray(JSONArray array, Object value) {
		boolean has = false;
		for (int i = 0; i < array.length(); i++) {
			if (value.equals(array.opt(i))) {
				has = true;
				break;
			}
		}
		if (!has) {
			array.put(value);
		}
	}

	public static void removeObjectFromJSONArray(JSONArray array, String value) {
		for (int i = 0; i < array.length(); i++) {
			if (value.equals(array.opt(i))) {
				array.remove(i);
				break;
			}
		}
	}

	public static List<JSONObject> convertCollectionToJSONObject(Collection<String> values, String key) {
		List<JSONObject> valueList = new ArrayList<JSONObject>();
		for (String value : values) {
			JSONObject obj = new JSONObject();
			try {
				obj.putOpt(key, value);
			} catch (JSONException e1) {
				e1.printStackTrace();
			}
			valueList.add(obj);
		}
		return valueList;
	}

	public static boolean contains(List<JSONObject> collections, JSONObject value, String key) {
		for (JSONObject obj : collections) {
			if (obj.optString(key).equals(value.optString(key))) {
				return true;
			}
		}
		return false;
	}
}
