package org.yaoqiang.bpmn.editor.dialog.panels;

import java.util.ArrayList;
import java.util.List;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JPanel;

import org.yaoqiang.bpmn.editor.dialog.XMLCheckboxPanel;
import org.yaoqiang.bpmn.editor.dialog.XMLComboPanel;
import org.yaoqiang.bpmn.editor.dialog.BPMNPanelContainer;
import org.yaoqiang.bpmn.editor.dialog.XMLTextPanel;
import org.yaoqiang.bpmn.editor.dialog.XMLPanel;
import org.yaoqiang.bpmn.model.elements.process.BPMNProcess;

/**
 * ProcessPanel
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class ProcessPanel extends XMLPanel {

	private static final long serialVersionUID = 1L;
	
	protected XMLPanel idPanel;
	protected XMLPanel namePanel;
	protected XMLComboPanel processTypePanel;
	protected XMLCheckboxPanel isExecutablePanel;
	protected XMLCheckboxPanel isClosedPanel;

	public ProcessPanel(BPMNPanelContainer pc, BPMNProcess owner) {
		super(pc, owner);
		this.setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		
		namePanel = new XMLTextPanel(pc, owner.get("name"));
		idPanel = new XMLTextPanel(pc, owner.get("id"));
		List<String> choices = new ArrayList<String>();
		choices.add(BPMNProcess.ProcessType.None.toString());
		choices.add(BPMNProcess.ProcessType.Private.toString());
		choices.add(BPMNProcess.ProcessType.Public.toString());
		processTypePanel = new XMLComboPanel(pc, owner.get("processType"), null, choices, false, false, true);
		isExecutablePanel = new XMLCheckboxPanel(pc, owner.get("isExecutable"), false);
		isClosedPanel = new XMLCheckboxPanel(pc, owner.get("isClosed"), false);

		JPanel exeClosePanel = new JPanel();
		exeClosePanel.setLayout(new BoxLayout(exeClosePanel,BoxLayout.X_AXIS));
		exeClosePanel.add(isExecutablePanel);
		exeClosePanel.add(Box.createHorizontalGlue());
		exeClosePanel.add(isClosedPanel);

		this.add(idPanel);
		this.add(namePanel);
		this.add(processTypePanel);
		this.add(exeClosePanel);
	}
	
	public void saveObjects() {
		idPanel.saveObjects();
		namePanel.saveObjects();
		processTypePanel.saveObjects();
		isExecutablePanel.saveObjects();
		isClosedPanel.saveObjects();
	}
	
	
}
