package org.yaoqiang.bpmn.model.elements.activities;

import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.XMLFactory;

/**
 * LoopTypes
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public class LoopTypes extends XMLFactory {

	private static final long serialVersionUID = -2423958092140243379L;
	
	public static final String TYPE_STANDARD_LOOPCHARACTERISTICS = "standardLoopCharacteristics";
	public static final String TYPE_MULTI_INSTANCE_LOOPCHARACTERISTICS = "multiInstanceLoopCharacteristics";
	
	public LoopTypes(XMLElement parent) {
		super(parent, "loopCharacteristics");
	}
	
	public XMLElement generateNewElement() {
		if (type.equals("multiInstanceLoopCharacteristics")) {
			return new MultiInstanceLoopCharacteristics(this);
		} else if (type.equals("standardLoopCharacteristics")) {
			return new StandardLoopCharacteristics(this);
		}
		return null;
	}

}
