package org.yaoqiang.bpmn.model.elements.core.common;

import java.util.List;

import org.yaoqiang.bpmn.model.elements.XMLElement;
import org.yaoqiang.bpmn.model.elements.artifacts.Artifacts;

/**
 * FlowElementsContainer
 * 
 * @author Shi Yaoqiang(shi_yaoqiang@yahoo.com)
 */
public interface FlowElementsContainer {

	public FlowElement getFlowElement(String id);
	
	public FlowElements getFlowElements();

	public List<FlowNode> getFlowNodes();

	public List<SequenceFlow> getSequenceFlows();
	
	public XMLElement generateFlowElement(String type);
	
	public void addFlowElement(XMLElement flowElement);
	
	public Artifacts getArtifacts();
	
	public void addFlowElements(FlowElements flowElements);

	public void addArtifacts(Artifacts artifacts);

	public void addArtifact(XMLElement artifact);

}
